#include <bits/stdc++.h>

using namespace std;

int main()
{   int zalihe[4];
    int n;
    int potrebno[10005];
    string grupa[10005];
    bool moze=true;
    int rezultat[10005][4]={};
    cin>>n;
    for(int i=0;i<4;i++)
        cin>>zalihe[i];
    for(int i=0;i<n;i++)
    {
        cin>>grupa[i]>>potrebno[i];
        if(grupa[i]=="O")
        {
            if(zalihe[0]>=potrebno[i])
            {
                zalihe[0]-=potrebno[i];
                rezultat[i][0]=potrebno[i];
            }
            else
                moze=false;
        }
        else if(grupa[i]=="A")
        {
            if(zalihe[1]>=potrebno[i])
            {
                zalihe[1]-=potrebno[i];
                rezultat[i][1]=potrebno[i];
            }
            else if(zalihe[1]+zalihe[0]>=potrebno[i])
            {
                rezultat[i][1]=zalihe[1];
                rezultat[i][0]=potrebno[i]-zalihe[1];
                zalihe[0]-=(potrebno[i]-zalihe[1]);
                zalihe[1]=0;
            }
            else moze=false;
        }
        else if(grupa[i]=="B")
        {
            if(zalihe[2]>=potrebno[i])
            {
                zalihe[2]-=potrebno[i];
                rezultat[i][2]=potrebno[i];
            }
            else if(zalihe[2]+zalihe[0]>=potrebno[i])
            {
                rezultat[i][2]=zalihe[2];
                rezultat[i][0]=potrebno[i]-zalihe[2];
                zalihe[0]-=(potrebno[i]-zalihe[2]);
                zalihe[2]=0;
            }
            else moze=false;
        }
    }
    for(int i=0;i<n;i++)
    {
        if(grupa[i]=="AB")
        {
            int r=potrebno[i],j=0,k;
            while(r>0&&j<4)
            {
                if(zalihe[j]>0)
                {
                    k=min(zalihe[j],r);
                    r-=k;
                    zalihe[j]-=k;
                    rezultat[i][j]=k;
                }
                j++;
            }
            if(r>0)
                moze=false;
        }
    }
    if(moze==false)
        cout << "nemoguce" << endl;
    else
    {
        cout << "moguce" << endl;
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<4;j++)
                cout << rezultat[i][j] << " ";
            cout << endl;
        }
    }
    return 0;
}